Subject: [IPP] RFC: "printer-cover (1setOf octetString(MAX))" and "printer-cover-description (1setOf text(MAX))"

From: Michael Sweet via ipp <[email-masked]>
Date: Tue, 23 Feb 2021 11:27:43 -0500

All,

As part of our discussions during the last F2F, we determined that IPP should expose the Printer MIB's prtCover element. The following proposal follows what we've done for other Printer MIB elements...

"printer-cover (1setOf octetString(MAX))"

This Printer Description attribute lists the cover sub-units associated with the Printer. Each value consists of a series of unordered key/value pairs that are structured according to the ABNF [STD68] [COVER-ABNF] defined in Figure N. The keywords are shown in Table N.

A Printer MUST encode the values of "printer-cover" using printable characters from the Net-ASCII subset of the US-ASCII character set [RFC5198].

This attribute MUST have the same cardinality (supply the same number of values) as the "printer-cover-description" (section ?.?.?) attribute. The ith value in the "printer-cover" attribute corresponds to the ith value in the "printer-cover-description" attribute.

Table N - Keywords for "printer-cover"

Printer MIB Element  IPP Data Type  IPP Keyword  Conformance
-------------------  -------------  -----------  -----------
prtCoverTable
prtCoverStatus       Integer        status       REQUIRED
prtCoverIndex        Integer        index        RECOMMENDED

Figure N - ABNF for "printer-cover" Values

printer-cover = 1*cover-required *cover-optional *cover-ext
cover-required = cover-status
cover-optional = cover-index
cover-ext      = cover-extname "=" cover-extvalue ";"
cover-extname  = 1*[ALPHA / DIGIT / "-"]
cover-extvalue = 1*[ALPHA / DIGIT / "-" / "." / ","]
cover-index    = "index=" 1*DIGIT ";"
cover-status   = "status=" 1*DIGIT ";"

"printer-cover-description (1setOf text(MAX))"

This Printer Description attribute provides a description of each cover sub-unit associated with the Printer.

When the descriptions are mapped from the prtCoverDescription element [RFC2790], they MUST be mapped using the following process:

1. The value of prtCoverDescription is converted from the character set specified by prtGeneralCurrentLocalization and prtLocalizationCharacterSet [RFC3805] to the character set specified by the "charset-configured" Printer Description attribute [STD92]; and

2. The new "printer-cover-description" value is tagged with the natural language specified by prtGeneralCurrentLocalization, prtLocalizationLanguage, and prtLocalizationCountry [RFC3805] unless the natural language matches the language to be used in the response as indicated by the "attributes-natural-language" operation attribute [STD92].

This attribute MUST have the same cardinality (supply the same number of values) as the "printer-cover" (section ?.?.?) attribute. The ith value in the "printer-cover-description" attribute corresponds to the ith value in the "printer-cover" attribute.

Thoughts?

________________________
Michael Sweet

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp

---

From: Ira McDonald via ipp <[email-masked]>
Date: Tue, 23 Feb 2021 15:41:30 -0500

Hi Mike,

LGTM +1

Cheers,
- Ira
*Ira McDonald (Musician / Software Architect)*

*Chair - SAE Trust Anchors and Authentication TF*
*Co-Chair - TCG Trusted Mobility Solutions WG*

*Co-Chair - TCG Metadata Access Protocol SG*

*Chair - Linux Foundation Open Printing WGSecretary - IEEE-ISTO Printer
Working GroupCo-Chair - IEEE-ISTO PWG Internet Printing Protocol WGIETF
Designated Expert - IPP & Printer MIBBlue Roof Music / High North
Inchttp://sites.google.com/site/blueroofmusic
<http://sites.google.com/site/blueroofmusic>http://sites.google.com/site/highnorthinc
<http://sites.google.com/site/highnorthinc>mailto: [email-masked]
<[email-masked]>(permanent) PO Box 221  Grand Marais, MI 49839
906-494-2434*

On Tue, Feb 23, 2021 at 11:27 AM Michael Sweet via ipp <[email-masked]> wrote:

> All,
>
> As part of our discussions during the last F2F, we determined that IPP
> should expose the Printer MIB's prtCover element. The following proposal
> follows what we've done for other Printer MIB elements...
>
> This Printer Description attribute lists the cover sub-units associated
> with the Printer. Each value consists of a series of unordered key/value
> pairs that are structured according to the ABNF [STD68] [COVER-ABNF]
> defined in Figure N. The keywords are shown in Table N.
>
> A Printer MUST encode the values of "printer-cover" using printable
> characters from the Net-ASCII subset of the US-ASCII character set
> [RFC5198].
>
> This attribute MUST have the same cardinality (supply the same number of
> values) as the "printer-cover-description" (section ?.?.?) attribute. The
> ith value in the "printer-cover" attribute corresponds to the ith value in
> the "printer-cover-description" attribute.
>
>
> When the descriptions are mapped from the prtCoverDescription element
> [RFC2790], they MUST be mapped using the following process:
>
> 1. The value of prtCoverDescription is converted from the character set
> specified by prtGeneralCurrentLocalization and
> prtLocalizationCharacterSet [RFC3805] to the character set specified by the
> "charset-configured" Printer Description attribute [STD92]; and
>
>
> 2. The new "printer-cover-description" value is tagged with the
> natural language specified by
> prtGeneralCurrentLocalization, prtLocalizationLanguage, and
> prtLocalizationCountry [RFC3805] unless the natural language matches
> the language to be used in the response as indicated by
> the "attributes-natural-language" operation attribute [STD92].
>
>
> This attribute MUST have the same cardinality (supply the same number of
> values) as the "printer-cover" (section ?.?.?) attribute. The ith value in
> the "printer-cover-description" attribute corresponds to the ith value in
> the "printer-cover" attribute.
>
>
> Thoughts?
>
> ________________________
> Michael Sweet
>
>
>